#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "graph.h"
#include "groups.h"

word seed,
     grp,
     grp_vert,
     lnk_vert,
     ene,
     prob;

word num_edges;


void init_rand (void) {

 srand (seed);

}


int rand_n (void) {

  return (rand () % 100 + 1);

}


int rand_grp (void) {

  return (rand () % grp_vert + 1);

}


void test_rand_n (void) {

  int i,
      j = 0,
      k = 0,
      l;

  for (i = 0; i < 30000; i++) {

    l = rand_n ();

    assert (l >= 1 && l <= 100);

    if (l <= 50)

      j++;

    else

      k++;

  }

}


void read_config (int argc, char *argv []) {

  FILE *config;

  if (argc != 7) {printf ("groups seed grps grps_verts arest_lig numb_esp_arest prob\n"); exit (0);}

  seed = atoi (argv [1]);
  grp = atoi (argv [2]);
  grp_vert = atoi (argv [3]);
  lnk_vert = atoi (argv [4]);
  ene = atoi (argv [5]); 
  prob = atoi (argv [6]); 

  /*printf ("seed %d\n", seed);
  printf ("columns %d\n", col);
  printf ("lines %d\n", lin);
  printf ("extra %d\n", ext);
  printf ("prob %d\n", prob);*/



}

/*
void build_random_net (graph *graph_ptr) {

  int i, j, k;


  graph_ptr->num_vertices = grp * grp_vert;


  graph_ptr->vert_ptr = ALLOC (graph_ptr->num_vertices + 1, vertex);


  graph_ptr->mate_ptr = ALLOC (graph_ptr->num_vertices + 1, mate);


  for (i = 0; i < grp; i++)

    for (j = i * grp_vert + 1; j < (i + 1) * grp_vert; j++)

      for (k = j + 1; k <= (i + 1) * grp_vert; k++)

	if (rand_n () <= prob)

	    add_edge (graph_ptr, j, k);

}
*/

void build_random_net (graph *graph_ptr) {

  int i, j, k;


  graph_ptr->num_vertices = grp * grp_vert;


  graph_ptr->vert_ptr = ALLOC (graph_ptr->num_vertices + 1, vertex);


  graph_ptr->mate_ptr = ALLOC (graph_ptr->num_vertices + 1, mate);


  for (i = 0; i < grp; i++)

    for (j = i * grp_vert + 1; j < (i + 1) * grp_vert; j++)

      for (k = 0; k < ene; k++)

	if (rand_n () <= prob) {

	  int l;

	  do l = rand_grp (); while (i * grp_vert + l == j);

	  assert (l >= 1 && l <= grp_vert);

	  assert (i * grp_vert + l != j);

	  if (!there_is_edge (graph_ptr, j, i * grp_vert + l))

	    add_edge (graph_ptr, j, i * grp_vert + l);

	}


  for (i = 0; i < grp - 1; i++)

    for (j = 0; j < lnk_vert; j++) {

      int k, l;

      k = i * grp_vert + rand_grp ();

      l = (i + 1) * grp_vert + rand_grp ();

      assert (k >= i * grp_vert + 1 && k <= i * grp_vert + grp_vert);

      assert (l >= (i + 1) * grp_vert + 1 && l <= (i + 1) * grp_vert + grp_vert);

      if (!there_is_edge (graph_ptr, k, l))

	add_edge (graph_ptr, k, l);

    }


  for (j = 0; j < lnk_vert; j++) {

    int k, l;

    k = (grp - 1) * grp_vert + rand_grp ();

    l = rand_grp ();

    assert (k >= (grp - 1) * grp_vert + 1 && k <= (grp - 1) * grp_vert + grp_vert);

    assert (l >= 1 && l <= grp_vert);

    if (!there_is_edge (graph_ptr, k, l))

      add_edge (graph_ptr, k, l);

  }

}



void save_graph (graph *graph_ptr, word edges) {


  FILE *output;

  int i;


  assert ((output = fopen (output_file, "w")) != NULL);

  fprintf (output, "c Gerador de grafos em forma de grade\n");
  fprintf (output, "s %d\n", seed);
  fprintf (output, "p %d %d\n", graph_ptr->num_vertices, edges);



  for (i = 1; i <= graph_ptr->num_vertices; i++) {

    edge *edge_ptr = graph_ptr->vert_ptr [i].edge_ptr;

    while (edge_ptr) {

      if (!edge_ptr->visited) {

	edge *edge_aux = graph_ptr->vert_ptr [edge_ptr->vert].edge_ptr;

	fprintf (output, "a %d %d\n", i, edge_ptr->vert);

	edge_ptr->visited = TRUE;

	while (edge_aux->vert != i)

	  edge_aux = edge_aux->next;

	edge_aux->visited = TRUE;

      }

      edge_ptr = edge_ptr->next;

    }



  }


  fclose (output);



}

void main (int argc, char *argv []) {

  graph *graph_ptr = ALLOC (1, graph);

  word edges;




  read_config (argc, argv);
/*
  seed = atoi (argv [1]);
  grp = atoi (argv [2]);
  grp_vert = atoi (argv [3]);
  lnk_vert = atoi (argv [4]);
  ene = atoi (argv [5]);
  prob = atoi (argv [6]);
*/
  init_rand ();

/*  test_rand_n ();*/

/*  build_all_net (graph_ptr);*/

  build_random_net (graph_ptr);

  maximal_matching (graph_ptr);

  edges = statistic_graph (graph_ptr);

  save_graph (graph_ptr, edges);

  free_graph (graph_ptr);

}
