/***********\
 * graph.h *
\***********/

/*======================*\
|* Optional definitions *|
\*======================*/


/*=====================*\
|* General definitions *|
\*=====================*/

#define input_file_name  "grf"
#define output_file_name "grf"

#define TRUE  1
#define FALSE 0

#define NORMAL  0       /* function exit: normal exit   */
#define ERROR  -1       /* function exit: abnormal exit */

#define ALLOC(X,Y) (Y*)calloc(X,sizeof(Y)) /* ALLOC (itens, type) */

/*=======================*\
|* Algorithm definitions *|
\*=======================*/


/*==================*\
|* type definitions *|
\*==================*/


typedef unsigned int word;

typedef int boole;

typedef struct vertex_node {

  word old_number,

       new_number;

} vertex;


typedef struct edge_node {

  word vertex_1,

       vertex_2;

} edge;


typedef struct graph_node {

  word num_vertices,

       num_edges;

  vertex *vertex_ptr;

  edge *edge_ptr;

} graph;


void init_rand (word);

word rand_n (word);

graph *input_graph (void);

void add_all_vertices (graph *);

void add_edge (graph *, word, word);

void shuffle_vertices (graph *);

void shuffle_edges (graph *);

void output_graph (graph *);

void free_graph (graph *);


