/*************************************************************************\
 * library.c - library of functions to manipulate adjaceny list of graph *
\*************************************************************************/

#include "graph.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <limits.h>
#include <assert.h>

word edge_next = 1;

void init_rand (word seed) {

 srand (seed);

}


word rand_n (word n) {

  return (rand () % n + 1);

}

void add_all_vertices (graph *graph_ptr) {


  word i;


  for (i = 1; i <= graph_ptr->num_vertices; i++) {

    graph_ptr->vertex_ptr [i].old_number =
    graph_ptr->vertex_ptr [i].new_number = i;

  }

}


void shuffle_vertices (graph *graph_ptr) {

  int i;


  for (i = graph_ptr->num_vertices; i >= 2; i--) {

    int n = rand_n (i);

    word tmp;


    assert (n >= 1 && n <= i);

    tmp = graph_ptr->vertex_ptr [i].new_number;

    graph_ptr->vertex_ptr [i].new_number =
    graph_ptr->vertex_ptr [n].new_number;

    graph_ptr->vertex_ptr [n].new_number = tmp;

  }


}


/* add_edge - insert an edge into the graph structure
   input    - graph, vertices i and j, (1 <= i,j <= n) */

void add_edge (graph *graph_ptr, word i, word j) {



  graph_ptr->edge_ptr [edge_next].vertex_1 = i;


  graph_ptr->edge_ptr [edge_next].vertex_2 = j;

  edge_next++;

}

void shuffle_edges (graph *graph_ptr) {

  int i;


  for (i = graph_ptr->num_edges; i >= 2; i--) {

    int n = rand_n (i);

    word tmp, tmp2;


    assert (n >= 1 && n <= i);

    tmp = graph_ptr->edge_ptr [i].vertex_1;
    tmp2 = graph_ptr->edge_ptr [i].vertex_2;

    graph_ptr->edge_ptr [i].vertex_1 =
    graph_ptr->edge_ptr [n].vertex_1;
    graph_ptr->edge_ptr [i].vertex_2 =
    graph_ptr->edge_ptr [n].vertex_2;

    graph_ptr->edge_ptr [n].vertex_1 = tmp;
    graph_ptr->edge_ptr [n].vertex_2 = tmp2;

  }

}


void free_graph (graph *graph_ptr) {


  free (graph_ptr->vertex_ptr);

  free (graph_ptr->edge_ptr);

  free (graph_ptr);


}
