/* main.c */

#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>



#include "graph.h"

#ifdef UNIX

#include <time.h>

#endif


void gen_point (graph *graph_ptr) {

  word count;

  for (count = 0; count < graph_ptr->num_vertices; count++) {

    putpixel (
    graph_ptr->point_ptr [count].x = random (400)
    ,
    graph_ptr->point_ptr [count].y = random (400),
    WHITE
    );
  }

}


void draw_graph (graph *graph_ptr) {

  word vert;

  clear_visited_marks (graph_ptr);

  /* print all the edges */

  for (vert = 0; vert < graph_ptr->num_vertices; vert++) {

    edge *edge_ptr = graph_ptr->vert_array [vert].edge_list;


    /* print all the edges of the vertex */

    while (edge_ptr != NULL) {

      if (!edge_ptr->visited) {

	edge_ptr->mate->visited = TRUE;

	line (graph_ptr->point_ptr [vert].x, graph_ptr->point_ptr [vert].y,
	      graph_ptr->point_ptr [edge_ptr->vertex].x, graph_ptr->point_ptr [edge_ptr->vertex].y);

	if (edge_ptr->matched) {


	}

      }

      edge_ptr = edge_ptr->next;

    }

  }

  clear_visited_marks (graph_ptr);

}



void draw_match (graph *graph_ptr) {

  word vert;

  clear_visited_marks (graph_ptr);

  setcolor (GREEN);

  /* print all the edges */

  for (vert = 0; vert < graph_ptr->num_vertices; vert++) {

    edge *edge_ptr = graph_ptr->vert_array [vert].edge_list;


    /* print all the edges of the vertex */

    while (edge_ptr != NULL) {

      if (!edge_ptr->visited) {

	edge_ptr->mate->visited = TRUE;

	if (edge_ptr->matched) {

	line (graph_ptr->point_ptr [vert].x, graph_ptr->point_ptr [vert].y,
	      graph_ptr->point_ptr [edge_ptr->vertex].x, graph_ptr->point_ptr [edge_ptr->vertex].y);

	}

      }

      edge_ptr = edge_ptr->next;

    }

  }

  clear_visited_marks (graph_ptr);

}




main (int argc, char *argv []) {

  graph *graph_ptr;
  int gdriver = DETECT, gmode, errorcode;

#ifdef UNIX

  time_t t_start, t_end;

#endif

  parse_command_line (argc, argv);

  graph_ptr = input_graph ();

/*  maximal_matching_1 (graph_ptr); */

  initgraph (&gdriver, &gmode, "");


  errorcode = graphresult();



  if (errorcode != grOk){

  exit (1);

  }
  verify_match (graph_ptr);

  graph_ptr->point_ptr = ALLOC (graph_ptr->num_vertices, point);

  gen_point (graph_ptr);

  draw_graph (graph_ptr);

#ifdef UNIX

  time (&t_start);

#endif

  getchar ();

  start_time ();

  general_matching_algorithm (graph_ptr);

#ifdef UNIX

  time (&t_end);

#endif

  end_time ();

  verify_match (graph_ptr);


  draw_match (graph_ptr);

  getchar ();

  closegraph ();

/*  verify_maximum_match (graph_ptr); */

  statistic_graph (graph_ptr);

#ifdef UNIX

  printf ("time %ld\n", (long) t_end - t_start);

#endif
  free (graph_ptr->point_ptr);

  free_graph (graph_ptr);

  return;

}
